<?php
/*
+--------------------------------------------------------------------------
|   IBITZY V 0.2 Beta
|   =============================================
|   Web: http://www.ipbtracker.eu/index.php?showforum=26
|	By: beeman
|	Created: 15/09/06
|	Last Edited: 20/09/06
+---------------------------------------------------------------------------
|   > Class for gather torrent data
|   > processing torrent data
|   > Writing data into database
|	> Getting torrents from multiple sites
+--------------------------------------------------------------------------
*/

@ini_set("max_execution_time", "300");
@ini_set ( "memory_limit", "160M");
$y = 0;

/**
* Spider Class
*
*/

class spider
{
	/**
	* Load vars for use in class
	*
	*/
	
	var $pluggin_arr = array();
	var $vars = array();
	var $site = '';
	var $conf = array();
	var $lib = array();
	var $cache = array();
	var $delete = "";
	var $failed = "";

	/*-------------------------------------------------------------------------*/
	// Run and process the sites list
	/*-------------------------------------------------------------------------*/
		
	function process_site()
	{
		//-----------------------------------------
		// Get the sites data
		//-----------------------------------------
		
		if( $this->vars->direct_connect == 1 )
		{
			$file = $this->direct_connect();
		}
		else 
		{
			$file = $this->file_get_content( $this->vars->to_spider );
		}
		
		//-----------------------------------------
		// Check if recache is needed
		//-----------------------------------------
		
		if( $file[1] == FALSE )
		{
			recache( $this->plugin_arr, $this->cache );
			$this->debug_output( '<meta http-equiv="refresh" content="30">Cant Connect to site; try again later or try to make an updated plugin.' );
			exit;
		}

		$out = $this->vars->main_match( $file[2] );
		
		$this->debug_output( 'Site connected...' );
		
		//-----------------------------------------
		// Check where we left off 
		// Check if data exists, and skip
		//-----------------------------------------
		
		$time = time() - 86400;
		
		$data = $this->mysql_debug("SELECT {$this->conf['sql']['site_tid']} 
							 		FROM {$this->conf['sql']['tbl_name']} 
							 		WHERE {$this->conf['sql']['date']} > {$time} 
							 		AND {$this->conf['sql']['site']} = '{$this->site}'
									");
							
		while( $res = mysql_fetch_array( $data ) )
		{
			$existing[ $res['site_tid'] ] = $res['site_tid'];
		}
		
		$data = $this->mysql_debug("SELECT tid 
							 		FROM un_processed 
							 		WHERE date > {$time} 
							 		AND site = '{$this->site}'
									");
		
		while( $res = mysql_fetch_array( $data ) )
		{
			$existing[ $res['tid'] ] = $res['tid'];
		}
		
		//--------------------------------------------------
		// If all is good, gather data ready for processing. 
		//--------------------------------------------------
		
		$this->debug_output( '<meta http-equiv="refresh" content="10">Processing site data...' );
		foreach( $out as $k )
		{
			if( $existing[ $k['id'] ] == '' )
			{
				$this->mysql_debug("INSERT INTO un_processed (tid, url, site, date, cat, subcat) 
							 		VALUES ('{$k['id']}',
							 		 '".mysql_real_escape_string($k['url'])."',
									 '{$this->site}',
									 '".time()."',
									 '".mysql_real_escape_string($k['cat'])."',
									 '".mysql_real_escape_string($k['subcat'])."')
							 		");
			}

		}
		$this->debug_output( '<meta http-equiv="refresh" content="5"><p>Added unprocessed tables...refreshing..</p>' );

	}
	/*-------------------------------------------------------------------------*/
	// mysql_debug
	/*-------------------------------------------------------------------------*/
	
	function debug_output( $output )
	{
		if( $this->conf['debug_mode'] == 1 )
		{
			echo $output."<br />\n";
			return;
		}
		else 
		{
			return;
		}
	}
	
	/*-------------------------------------------------------------------------*/
	// mysql_debug
	/*-------------------------------------------------------------------------*/
	
	function mysql_debug( $sql )
	{
		if( $this->conf['debug_mode'] == 1 )
		{
			$return = mysql_query( $sql ) or die( $sql ."<br />\n<br />\n". mysql_error());
		}
		else 
		{
			$return = mysql_query( $sql );
		}
		
		return $return;
	}
	
	/*-------------------------------------------------------------------------*/
	// Direct Connect
	/*-------------------------------------------------------------------------*/
		
	function direct_connect()
	{
		$fp = @fsockopen ( $this->vars->spider_root_addr, 80, $errno, $errstr, 30 );
		if( !$fp ) 
		{
			return array(1 => FALSE, 2 => ''); 
		} 
		else 
		{
			@fwrite( $fp, "POST {$this->vars->spider_path} HTTP/1.1\r\nHost: {$this->vars->spider_root_addr}\r\n{$this->vars->cookies}Connection: Keep-Alive\r\n\r\n" );
 			$data = '';
   			while( !feof( $fp ) ) 
   			{
       			$data .= @fread( $fp, 4096 );
       			if( substr( $data, -9 )== "\r\n\r\n0\r\n\r\n" ) 
       			{
       				return array( 1 => FALSE, 2 => '' ); 
      			}
   			}
		}
		return array( 1 => TRUE, 2 => $data );
	}

	
	/*-------------------------------------------------------------------------*/
	// Get file content
	/*-------------------------------------------------------------------------*/
	
	function file_get_content( $url )
	{
		for( $i = 1; $c <= $this->conf['tries']; $c++ )
		{
			$file = @file_get_contents( $url );
			if( $file != FALSE )
			{
				return array( 1 => TRUE, 2 => $file );
				break;
			}
		}
		return array( 1 => FALSE, 2 => '' ); 
	}

	/*-------------------------------------------------------------------------*/
	// Process data into gathering torrents and torrent data
	/*-------------------------------------------------------------------------*/
		
	function process()
	{

		//-----------------------------------------
		// Is the process locked?
		//-----------------------------------------
		
		if( $this->cache['locked'] == 'locked' && $this->cache['lock_time'] > time() - 1800 )
		{
			$this->debug_output( '<font color="#FF0000"><meta http-equiv="refresh" content="900"><p align="center"><b>Locked => wait some time OR......</b></font></p>

<script language="JavaScript">
<!--
	// DATE PRINT
	document.write(\'<font color="#FF0000"><p style="margin-top: 0; margin-bottom: 0" align="center">\' + (new Date).toLocaleString() + \'</font></p>\');
//-->
</script>

<p align="center"><SCRIPT LANGUAGE="JavaScript">
<!-- Begin popup
function popUp(URL) {
day = new Date();
id = day.getTime();
eval("page" + id + " = window.open(URL, \'" + id + "\', \'toolbar=0,scrollbars=0,location=0,statusbar=0,menubar=0,resizable=0,width=250,height=100,left = 412,top = 284\');");
}
// End -->
</script>
<p align="center">
<input type=button value="Unlock Scooter" onClick="javascript:popUp(\'cachefix.php\')"><br />
<font color="#FF0000"><b>Make sure to check for dupes after processing!</b><BR><BR><form action="#">
<div align="center">
<input type="button" value="Reload!" onClick="window.location.reload()"></input>
</div>
</form>
</font></p>

</form>

' );
			exit;
		}

		$this->lock_file( $this->pluggin_arr, $this->cache );

		//-----------------------------------------
		// Load benc class
		//-----------------------------------------
		
		$this->lib = new lib_benc;		
		
		//-----------------------------------------
		// Load each pluggin
		//-----------------------------------------
		foreach ( $this->pluggin_arr as $k => $v )
		{
			@include( 'pluggins/'. $v['source'] );
			$this->pluggin[ $k ] = new $v['class'];
			$this->pluggin[ $k ]->conf = $this->conf;
		}
		
		//-----------------------------------------
		// Gather unprocessed data to process
		//-----------------------------------------		
		
		$data = $this->mysql_debug("SELECT * 
							 		FROM un_processed 
							 		WHERE status != 'in_process' 
									LIMIT {$this->conf['processes']}
									");
							
		while ( $row = mysql_fetch_array( $data ) )
		{
			//-----------------------------------------
			// If theres nothing to do exit. 
			//-----------------------------------------
			
			if ( $row['tid'] == '' )
			{
				$this->debug_output( '<meta http-equiv="refresh" content="30">No files to process!! Try debugging and setting different cache intervals!' );
				exit;
			}	
			
			//--------------------------------------------
			// Gather id's to set all "in_process" 
			// in 1 query.
			//--------------------------------------------
			
			$in .= $row['tid'].', ';
			
			$each[ $row['tid'] ] = $row;
		}
		
		//--------------------------------------------
		// Update data being processed to "in_process"
		// so its not processed twice. 
		//--------------------------------------------
			
		$in = substr($in, 0, -2);	
		
		if( $in != '' )
		{
			$this->mysql_debug("UPDATE un_processed 
						  		SET status='in_process' 
						  		WHERE tid IN({$in})
						 		");
		}
		
		//--------------------------------------------
		// Process torrents
		//--------------------------------------------
				
		foreach( $each as $row )
		{
			$this->process_torrent( $row['tid'], $row['site'], $row['url'], $row );
		}
		
		//--------------------------------------------
		// Success now delete!
		//--------------------------------------------
		
		if( $this->delete != "" )
		{
			$delete = substr($this->delete, 0, -2);
			$this->mysql_debug( "DELETE FROM un_processed WHERE tid IN({$delete})" );
		}
		
		//--------------------------------------------
		// You total failer :P
		//--------------------------------------------
		
		if( $this->failed != "" )
		{
			$failed = substr( $this->failed, 0, -2 );
			$this->mysql_debug( "UPDATE un_processed SET status='failed' WHERE tid IN({$failed})" );
		}
		
		$this->debug_output( '<meta http-equiv="refresh" content="10">Added new un_processed URLS into MySQL.<br />Refresh to begin processing.' );
	}
	
	
	/*-------------------------------------------------------------------------*/
	// Finally process the torrent, gather torrent data and torrents
	/*-------------------------------------------------------------------------*/	
	
	function process_torrent( $tinfo, $site, $url, $row )
	{
		//-----------------------------------------
		// Get the file 
		//-----------------------------------------
		
		$file = $this->file_get_content( $url );
		
		//-----------------------------------------
		// If sucessful, continue
		//-----------------------------------------		
		
		if ( $file[1] == TRUE )
		{
			//-----------------------------------------
			// Gather torrent details from site
			//-----------------------------------------

			$torrent['name'] = htmlentities( $this->pluggin[ $site ]->match_name( $file[2] ) );
			$torrent['cat'] = $this->pluggin[ $site ]->process_cat( $file[2] );
			$torrent['sub'] = $this->pluggin[ $site ]->process_cat( $file[2] );
			$cat_extra = $this->pluggin[ $site ]->cat_code_extra( $torrent['cat'], $torrent['sub'], $row );
			$torrent['cat'] = $cat_extra['cat'];
			$torrent['sub'] = $cat_extra['sub'];
			$torrent['magnet'] = $this->pluggin[ $site ]->process_magnet( $file[2] );
			$torrent['dlurl'] = $this->pluggin[ $site ]->process_download( $file[2], $tinfo );
			$torrent['dl_name'] = str_replace(' ','_',$torrent['name']);
			$torrent['dl_name'] = $torrent['dl_name'] . '.torrent';

			//-----------------------------------------
			// Finally decode the .torrent
			//-----------------------------------------
			
			$t['file'] = $this->file_get_content( $torrent['dlurl'] );
			
			if ( $t['file'][1] == TRUE )
			{
				$t_file = $this->lib->bdec( $t['file'][2] );
				$torrent['info_hash'] = sha1( $this->lib->benc( $t_file['value']['info'] ) );
				$torrent['pcount'] = $t_file['value']['info']['value']['pieces']['strlen'] / 20;
				$torrent['plength'] = $t_file['value']['info']['value']['piece length']['value'];
				$torrent['size'] = $torrent['pcount'] * $torrent['plength'];
				$torrent['announce'] = $t_file['value']['announce']['value'];
				
				if ( $torrent['announce'] == '' )
				{	
					$this->debug_output( 'This torrent dosnt look right, cant find an announce url' );
					$this->delete .= $tinfo.', ';
					return;
				}
				
				//-----------------------------------------
				// Do we already have this torrent?
				//-----------------------------------------
				
				$sql = $this->mysql_debug("SELECT count(*) 
											FROM {$this->conf['sql']['tbl_name']} 
											WHERE {$this->conf['sql']['info_hash']}='{$torrent['info_hash']}' 
											AND {$this->conf['sql']['announce']}='{$torrent['announce']}'" 
								   			);
								   
				$count = mysql_fetch_array( $sql );

				//-----------------------------------------
				// If yes delete it
				//-----------------------------------------	
							
				if ( $count[0] > 0 )
				{
					$this->debug_output( 'We already have this one...skipping.' );
					$this->delete .= $tinfo.', ';
					return;
				}
				else 
				{
					//-----------------------------------------
					// Sucessful, construct the query
					//-----------------------------------------
					
					
					$tracker 		= strip_tags($torrent['announce']);
                    $tracker 		= strip_tags(str_replace('announce', 'scrape', $tracker));  
				    $stats 			= torrent_scrape_url($tracker, $torrent['info_hash']);
					$seeds 			= strip_tags($stats['seeds']);
					$peers 			= strip_tags($stats['peers']);
					$torrentname 	= trim(strip_tags($torrent['name']));
					$torrentname    = addslashes($torrentname);

					/*if (intval( $torrent['cat'] )   == 1)
					{	
					$subcat = 23;
					} elseif (intval( $torrent['cat'] )   == 2)
					{
					$subcat = 80;
					} elseif (intval( $torrent['cat'] )   == 3)
					{
					$subcat = 57;
					} elseif (intval( $torrent['cat'] )   == 4)
					{
					$subcat = 15;
					} elseif (intval( $torrent['cat'] )   == 5)
					{
					$subcat = 72;
					} elseif (intval( $torrent['cat'] )   == 6)
					{
					$subcat = 75;
					} elseif (intval( $torrent['cat'] )   == 7)
					{
					$subcat = 123;
					} else
					{
					$subcat = 123;
					}
*/
					$q = "INSERT INTO {$this->conf['sql']['tbl_name']} 
									  ({$this->conf['sql']['torrent_name']},
									  {$this->conf['sql']['cat']},
									  {$this->conf['sql']['subcat']},
									  {$this->conf['sql']['size']},
									  {$this->conf['sql']['info_hash']},
									  {$this->conf['sql']['site_tid']},
									  {$this->conf['sql']['site']},
									  {$this->conf['sql']['date']},
									  {$this->conf['sql']['announce']},
									  {$this->conf['sql']['seeds']},
									  {$this->conf['sql']['peers']}) 
						  VALUES ('".$torrentname."',
						  		  '".intval( $torrent['cat'] ) ."',
								  '{$subcat}',
								  '{$torrent['size']}',
								  '". mysql_real_escape_string( $torrent['info_hash'] ) ."',
								  '{$tinfo}',
								  '". mysql_real_escape_string( $site ) ."',
								  '". date('YmdHis')."',
								  '". mysql_real_escape_string( $tracker ) ."',
								  '".$seeds."',
								  '".$peers."')
							";
							
					//-----------------------------------------
					// Run the query or error
					//-----------------------------------------	
											
					$this->mysql_debug( $q );
					$id = mysql_insert_id();
					
					//-----------------------------------------
					// Save the torrent in torrent directory
					//-----------------------------------------
					
					$file_put =  fopen( $this->conf['torrent_dir'] . $torrent['info_hash'] . '.torrent', 'x' );
					$this->delete .= $tinfo.',';
					fwrite ( $file_put, $t['file'][2] );
					fclose ( $file_put );
					$this->delete .= $tinfo.',';
					$this->debug_output( '<b>Torrent constructed & inserted successfully!</b>' );
					return;
				}
			}
			
			//-------------------------------------------------
			// oOps got tinfo but not torrent so lets update DB
			//-------------------------------------------------
			
			$this->debug_output( 'Torrent file seems to be missing...skipping.' );
			$this->failed .= $tinfo.', ';
			return;
		}

		//-----------------------------------------
		// Total failure, update DB 
		//-----------------------------------------
		
		$this->debug_output( 'Torrent file seems to be missing a site_tid, skipping.' );
		
		$this->failed .= $tinfo.', ';
		return;
	}

	/*-------------------------------------------------------------------------*/
	// Lock file function 
	/*-------------------------------------------------------------------------*/	
		
	function lock_file($pluggin, $cache )
	{
		//-----------------------------------------
		// Lock file to stop dupes and multiple 
		// executions of script
		//-----------------------------------------

		$file = fopen( 'cached.php', w );
		$return = "<?php\n\n//-----------------------------------------\n// Cache file\n//-----------------------------------------\n\n";
		foreach( $pluggin as $k => $v ) 
		{
			$time = $cache['site'][ $k ]+1;
			$return .= '$cache[\'site\'][\''.$k.'\'] = ' . $time . ";\n";
		}
		$query = $this->mysql_debug('SELECT COUNT(id) FROM un_processed') or die( mysql_error() );
		$count = mysql_fetch_array( $query );
		$return .= '$cache[\'unprocessed\'] = ' . $count[0] . ";\n";
		$return .= '$cache[\'locked\'] = \'locked\';' . "\n";
		$return .= '$cache[\'lock_time\'] = ' . time() . ";\n";
		fwrite( $file, $return );
	}

}	
?>	